unit uTICQClientDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ICQClient, ICQWorks;

type
  TForm1 = class(TForm)
    leSN: TLabeledEdit;
    lePass: TLabeledEdit;
    Bevel1: TBevel;
    btnConnect: TButton;
    btnDisconnect: TButton;
    Bevel2: TBevel;
    mmLog: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
  private
    { Private declarations }
  public
    ICQClient: TICQClient;
    procedure OnICQLogin(Sender: TObject);
    procedure OnICQDisconnected(Sender : TObject; Error : Integer; Msg : String);
    procedure OnICQError(Sender: TObject; ErrorType: TErrorType; ErrorMsg: String; ErrorAddType: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  ICQClient.UIN:= StrToIntDef(Trim(leSN.Text), 0);
  ICQClient.Password  := Trim(lePass.Text);

  if (ICQClient.UIN = 0) or (ICQClient.Password = '') then
  begin
    mmLog.Lines.Append('Invalid UIN or Password...');
    Exit;
  end;

  ICQClient.OnLogin:= OnICQLogin;
  ICQClient.OnError:= OnICQError;
  ICQClient.OnConnectionFailed:= OnICQDisconnected;

  mmLog.Lines.Append('Connecting...');
  ICQClient.Login();
  
  btnConnect.Enabled:= False;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
  ICQClient.LogOff;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ICQClient:= TICQClient.Create(nil);
  ICQClient.DisableDirectConnections:= True;
  ICQClient.ICQServer:= 'login.icq.com';
  ICQClient.ICQPort:= '5190';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(ICQClient) then
  begin
    if ICQClient.LoggedIn then ICQClient.Disconnect;
    FreeAndNil(ICQClient);
  end;  
end;

procedure TForm1.OnICQDisconnected(Sender : TObject; Error : Integer; Msg : String);
begin
  btnDisconnect.Enabled:= False;
  btnConnect.Enabled:= True;
  mmLog.Lines.Append('Disconnected...');
end;

procedure TForm1.OnICQError(Sender: TObject; ErrorType: TErrorType;
  ErrorMsg: String; ErrorAddType: integer);
begin
  mmLog.Lines.Append('Error: '+ ErrorMsg);
end;

procedure TForm1.OnICQLogin(Sender: TObject);
begin
  btnDisconnect.Enabled:= True;
  mmLog.Lines.Append('Connected...');
end;

end.
